/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 * 
 *  DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 *
 *  This code is free software; you can redistribute it and/or modify it
 *  under the terms of the GNU General Public License version 3, 
 *  or (at your option) any later version, as published by the Free Software Foundation.  
 *  The authors designate this particular file as subject to the "Classpath" exception 
 *  as provided in the LICENSE file that accompanied this code.
 *
 *  This code is distributed in the hope that it will be useful, but WITHOUT
 *  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 *  version 3 for more details (a copy is included in the LICENSE file that
 *  accompanied this code).
 *
 *  You should have received a copy of the GNU General Public License version 3
 *  along with this work; if not, see http://www.gnu.org/licenses/gpl-3.0.txt 
 *
 *  Please contact visnow.org or visit www.visnow.org if you need additional information or
 *  have any questions.
 *
 */

package org.visnow.vn.lib.basic.mappers.RegularFieldSlice;

import org.apache.log4j.Logger;
import org.visnow.vn.engine.core.ParameterProxy;
import org.visnow.vn.engine.core.Parameters;
import static org.visnow.vn.lib.basic.mappers.RegularFieldSlice.RegularFieldSliceShared.*;

public class RegularFieldSliceGUI extends javax.swing.JPanel
{
    private static final Logger LOGGER = Logger.getLogger(RegularFieldSliceGUI.class);

    protected Parameters parameters = null;
    protected int[] dims = null;

    /**
     * Default constructor.
     * Creates new form RegularFieldSliceGUI.
     */
    public RegularFieldSliceGUI()
    {
        initComponents();
    }

    /**
     * Empty constructor.
     * Used, when RegularFieldSliceGUI is extended to other alternative GUI class
     * (all of the Swing components are replaced - no initComponents() method should be called here - it should be called in subclass).
     * 
     * @param overrideComponents Doesn't matter if it's true or false - parameter is used only to differ signature from default constructor
     */
    public RegularFieldSliceGUI(boolean overrideComponents)
    {
    }
    
    public void updateGUI(ParameterProxy p, boolean resetGUIControls)
    {

        int sliceIndex = p.get(SLICE_INDEX);
        int[] dimLengths = p.get(META_FIELD_DIMENSION_LENGTHS);
        int dimLength = dimLengths[p.get(SELECTED_AXIS)];

        if (resetGUIControls) sliceSlider.setMax(dimLength - 1);

        sliceSlider.setGlobalMax(dimLength - 1);
        sliceSlider.setValue(p.get(SLICE_INDEX));

        iRadioButton.setSelected(p.get(SELECTED_AXIS) == 0);
        jRadioButton.setSelected(p.get(SELECTED_AXIS) == 1);
        kRadioButton.setSelected(p.get(SELECTED_AXIS) == 2);

        recalculateMinMaxCB.setSelected(p.get(RECALCULATE_MIN_MAX));
    }

    /**
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents()
    {
        java.awt.GridBagConstraints gridBagConstraints;

        axesGroup = new javax.swing.ButtonGroup();
        axisPanel = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        iRadioButton = new org.visnow.vn.gui.swingwrappers.RadioButton();
        jRadioButton = new org.visnow.vn.gui.swingwrappers.RadioButton();
        kRadioButton = new org.visnow.vn.gui.swingwrappers.RadioButton();
        jLabel2 = new javax.swing.JLabel();
        sliceSlider = new org.visnow.vn.gui.widgets.ExtendedSlider();
        recalculateMinMaxCB = new javax.swing.JCheckBox();
        filler1 = new javax.swing.Box.Filler(new java.awt.Dimension(0, 0), new java.awt.Dimension(0, 0), new java.awt.Dimension(0, 32767));

        setBorder(javax.swing.BorderFactory.createEmptyBorder(4, 4, 4, 4));
        setLayout(new java.awt.GridBagLayout());

        axisPanel.setLayout(new java.awt.GridBagLayout());

        jLabel1.setText("Axis:"); // NOI18N
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 0;
        axisPanel.add(jLabel1, gridBagConstraints);

        axesGroup.add(iRadioButton);
        iRadioButton.setSelected(true);
        iRadioButton.setText("i"); // NOI18N
        iRadioButton.addUserActionListener(new org.visnow.vn.gui.swingwrappers.UserActionListener()
        {
            public void userChangeAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)
            {
                axisRBActionPerformed(evt);
            }
            public void userAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)
            {
            }
        });
        axisPanel.add(iRadioButton, new java.awt.GridBagConstraints());

        axesGroup.add(jRadioButton);
        jRadioButton.setText("j"); // NOI18N
        jRadioButton.addUserActionListener(new org.visnow.vn.gui.swingwrappers.UserActionListener()
        {
            public void userChangeAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)
            {
                axisRBActionPerformed(evt);
            }
            public void userAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)
            {
            }
        });
        axisPanel.add(jRadioButton, new java.awt.GridBagConstraints());

        axesGroup.add(kRadioButton);
        kRadioButton.setText("k");
        kRadioButton.addUserActionListener(new org.visnow.vn.gui.swingwrappers.UserActionListener()
        {
            public void userChangeAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)
            {
                axisRBActionPerformed(evt);
            }
            public void userAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)
            {
            }
        });
        axisPanel.add(kRadioButton, new java.awt.GridBagConstraints());

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        add(axisPanel, gridBagConstraints);

        jLabel2.setText("Slice:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        add(jLabel2, gridBagConstraints);

        sliceSlider.setFieldType(org.visnow.vn.gui.components.NumericTextField.FieldType.INT);
        sliceSlider.setGlobalMin(0);
        sliceSlider.setShowingFields(true);
        sliceSlider.addUserActionListener(new org.visnow.vn.gui.swingwrappers.UserActionListener()
        {
            public void userChangeAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)
            {
            }
            public void userAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)
            {
                sliceSliderUserAction(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        add(sliceSlider, gridBagConstraints);

        recalculateMinMaxCB.setText("Recalculate min, max");
        recalculateMinMaxCB.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                recalculateMinMaxCBActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        add(recalculateMinMaxCB, gridBagConstraints);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.weighty = 1.0;
        add(filler1, gridBagConstraints);
    }// </editor-fold>//GEN-END:initComponents

    /**
     * Set the value of params
     *
     * @param params new value of params
     */
    public void setParameters(Parameters parameters)
    {
        this.parameters = parameters;
    }

    private void recalculateMinMaxCBActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_recalculateMinMaxCBActionPerformed
        parameters.set(RECALCULATE_MIN_MAX, recalculateMinMaxCB.isSelected());
    }//GEN-LAST:event_recalculateMinMaxCBActionPerformed

    private void axisRBActionPerformed(org.visnow.vn.gui.swingwrappers.UserEvent evt)//GEN-FIRST:event_axisRBActionPerformed
    {//GEN-HEADEREND:event_axisRBActionPerformed
        int axis = evt.getSource() == iRadioButton ? 0 : evt.getSource() == jRadioButton ? 1 : 2;
        int dimLength = parameters.get(META_FIELD_DIMENSION_LENGTHS)[axis];
        int sliceIndex = parameters.get(SLICE_INDEX);

        parameters.setParameterActive(false);
        sliceSlider.setGlobalMax(dimLength - 1);
        sliceSlider.setMax(dimLength - 1);
        sliceSlider.setMin(0);
        parameters.setParameterActive(true);

        if (sliceIndex > dimLength) {
            parameters.set(SELECTED_AXIS, axis,
                           SLICE_INDEX, getSmartSlice(dimLength));
        } else
            parameters.set(SELECTED_AXIS, axis);
    }//GEN-LAST:event_axisRBActionPerformed

    private void sliceSliderUserAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)//GEN-FIRST:event_sliceSliderUserAction
    {//GEN-HEADEREND:event_sliceSliderUserAction
//        if (!sliceSlider.isAdjusting())
        parameters.set(SLICE_INDEX, (Integer) sliceSlider.getValue(),
                       ADJUSTING, sliceSlider.isAdjusting());
    }//GEN-LAST:event_sliceSliderUserAction

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.ButtonGroup axesGroup;
    private javax.swing.JPanel axisPanel;
    private javax.swing.Box.Filler filler1;
    private org.visnow.vn.gui.swingwrappers.RadioButton iRadioButton;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private org.visnow.vn.gui.swingwrappers.RadioButton jRadioButton;
    private org.visnow.vn.gui.swingwrappers.RadioButton kRadioButton;
    private javax.swing.JCheckBox recalculateMinMaxCB;
    private org.visnow.vn.gui.widgets.ExtendedSlider sliceSlider;
    // End of variables declaration//GEN-END:variables
}
